# std::dec, std::hex, std::oct

From cppreference.com
< cpp‎ | io‎ | manip

Defined in header `<ios>` |  |
std::ios_base& dec( std::ios_base& str ); | (1) |
std::ios_base& hex( std::ios_base& str ); | (2) |
std::ios_base& oct( std::ios_base& str ); | (3) |

Modifies the default numeric base for integer I/O.

1) sets the `basefield` of the stream `str` to `dec` as if by calling str.setf(std::ios_base::dec, std::ios_base::basefield)

2) sets the `basefield` of the stream `str` to `hex` as if by calling str.setf(std::ios_base::hex, std::ios_base::basefield)

3) sets the `basefield` of the stream `str` to `oct` as if by calling str.setf(std::ios_base::oct, std::ios_base::basefield)

This is an I/O manipulator. It may be called with an expression such as out << std::hex for any `out` of type std::basic_ostream or with an expression such as in >> std::hex for any `in` of type std::basic_istream.

### Parameters

str | - | reference to I/O stream

### Return value

`str` (reference to the stream after manipulation)

### Example

Run this code

    #include <iostream>
    #include <sstream>
    int main()
    {
        std::cout << "The number 42 in octal:   " << std::oct << 42 << '\n'
                  << "The number 42 in decimal: " << std::dec << 42 << '\n'
                  << "The number 42 in hex:     " << std::hex << 42 << '\n';
        int n;
        std::istringstream("2A") >> std::hex >> n;
        std::cout << std::dec << "Parsing \"2A\" as hex gives " << n << '\n';
    }

Output:

    The number 42 in octal:   52
    The number 42 in decimal: 42
    The number 42 in hex:     2a
    Parsing "2A" as hex gives 42

### See also

setbase | changes the base used for integer I/O (function)
showbase noshowbase | controls whether prefix is used to indicate numeric base (function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/io/manip/hex&oldid=78784"